;B+ Chinese DEMO
; Compile with FASM for Menuet
;E:.
   
;B+ System header
use32
org 0x0
 db  'MENUET01'
 dd  0x01
 dd  START
 dd  CODE_END
 dd  0x100000
 dd  0x7fff0
 dd  0x0,0x0
 prog_mask equ 111b
;E:.
   
include 'chinese.inc'
   
IPC_event: ;If use other IPC
  ret      ;  move, if use
   
START:
  call chinese.init_print
;B+ Events
red:
  or   [draw_mask],1
still:
  test [draw_mask],1
  jz   .no_draw_all
  and  [draw_mask],not 1
  call draw_window
.no_draw_all:
  ;wait for events
  mov  eax,10
  int  0x40
  cmp  eax,1
  je   red
  cmp  eax,2
  jne  .no_key
  mov  eax,2
  int  0x40
  jmp  still
.no_key:
  cmp  eax,3
  jne  still
  mov  eax,17
  int  0x40
  cmp  ah,1
  jne  still
  ;finish
  mov  eax,-1
  int  0x40
;E:.
draw_window:
;B+ Window redraw
  mov  ebx,1
  mov  eax,12
  int  0x40
   
  ;draw window skin 3
  mov  ebx,100*65536+120
  mov  ecx,100*65536+50
  mov  edx,0x00aaaaaa
  mov  esi,0x8050d0d0
  mov  edi,0x0050d0d0
  mov  eax,0
  int  0x40
   
  ;close button
  mov  ebx,(120-19)*65536+12
  mov  ecx,5*65536+12
  mov  edx,1
  mov  esi,0x10c010
  mov  eax,8
  int  0x40
   
  ;draw english text
  mov  ebx,8*65536+8
  mov  ecx,0xffffff
  mov  edx,ct
  mov  esi,ct_end-ct
  mov  eax,4
  int  0x40
   
  ;draw chinese text
  mov  ebx,10*65536+27
  mov  ecx,0xffffff
  mov  edx,0xaaaaaa
  mov  esi,c_text
  mov  edi,6
  call chinese.print
   
  mov  ebx,2
  mov  eax,12
  int  0x40
  ret
;E:.
;B+ Data - graphics improve
draw_mask dd 1b
;E:.
   
;B+ Data section
ct db 'CHINESE TEXT'
ct_end:
c_text dw 1,2,3,4,5,3
;E:.
   
CODE_END:
   