;B+ Chinese "driver"
; Compile with FASM for Menuet
;E:.
   
;B+ System header
use32
org 0x0
 db  'MENUET01'
 dd  0x01
 dd  START
 dd  I_END
 dd  0x100000
 dd  0x7fff0
 dd  0x0,0x0
;E:.
   
;B+ Definitions
MAX  equ 50
chinese_text equ I_END
set8         equ I_END+4
send_process equ I_END+8
;message size
text_length  equ I_END+16
color_text   equ I_END+20
color_backgr equ I_END+24
text_data    equ I_END+28
   
chinese_image equ text_data+2*MAX
ci_width      equ chinese_image
ci_image      equ chinese_image+4
   
imagefile     equ ci_image+3*17*17*MAX
;E:.
   
init:
;B+ Init
;B+ Init buffers
  mov  dword [chinese_text],0
  mov  dword [set8],8
;E:.
;B+ Load images file
  mov  ebx,filename
  mov  ecx,0
  mov  edx,-1
  mov  esi,imagefile
  mov  eax,6
  int  0x40
;E:.
;B+ Define receive area
  mov  ebx,1
  mov  ecx,chinese_text
  mov  edx,(MAX*2+4*4+4*1)
  mov  eax,60
  int  0x40
;E:.
;B+ Set IPC event mask
  mov  ebx,01000110b
  mov  eax,40
  int  0x40
;E:.
  ret
;E:.
   
START:
  call init
;B+ Events
still:
  mov  eax,10
  int  0x40
;B+ Keyboard ignore
  cmp  eax,2
  jne  .no_key
  mov  eax,2
  int  0x40
  jmp  still
.no_key:
;E:.
  cmp  eax,7
  jne  still
;E:.
;B+ IPC make
  mov  byte [chinese_text],1
;B+ Draw "char" in memory
 push dword 0
  ;width in pixels
  mov  ebx,[text_length]
  mov  eax,17
  mul  ebx
  mov  dword [ci_width],eax
  ;add size to next line
  mov  ebx,[text_length]
  dec  ebx
  mov  eax,3*17
  mul  ebx
 push eax
  ;save number of "chars"
 push dword [text_length]
  ;
  cld
 push ci_image-3*17
.next_char:
  mov  eax,[esp+12]
  mov  ax,[text_data+2*eax]
  and  eax,0x0fff
  shl  eax,5    ;*16*16/8
  add  eax,imagefile
  mov  [pointer],eax
  inc  dword [esp+12]
   
  add  dword [esp],3*17
  mov  edi,[esp]
   
;B+ Draw 1 "char"
  mov  ah,1
 push 2
.next_line:
  ;one screen line
  mov  edx,[pointer]
  ;
  mov  ebx,16
.next_pixel:
  mov  al,[edx]
  mov  esi,color_text
  test al,ah
  jnz  .yes_pixel
  mov  esi,color_backgr
.yes_pixel:
  ;one pixel
  mov  ecx,3
rep movsb
  inc  edx
  dec  ebx
  jnz  .next_pixel
  ;
  ;set space
;  mov  ebx,2 ...
  mov  esi,color_backgr
  mov  ecx,3
rep movsb
  add  edi,[esp+12]
  shl  ah,1
  jnz  .next_line
  add  [pointer],16
  mov  ah,1
  dec  dword [esp]
  jnz  .next_line
 pop  edx
;E:.
   
  dec  dword [esp+4]
  jnz  .next_char
   
  ;set empty line(s)
  sub  edi,[esp+8]
  mov  eax,[text_length]
  shl  eax,4             ;*16
  add  eax,[text_length] ;*17
  inc  eax
.next_pixel1:
  mov  ecx,3
  mov  esi,color_backgr
rep movsb
  dec  eax
  jnz  .next_pixel1
  ;find image size
  sub  edi,ci_image
  mov  esi,edi
  add  esp,12
;E:.
;B+ Send result
  mov  dword [set8],8
  ;esi - message size
  mov  ebx,2
  mov  ecx,[send_process]
  and  ecx,0xfff
  mov  edx,chinese_image
  mov  eax,60
  int  0x40
;E:.
  mov  byte [chinese_text],0
  jmp  still
;E:.
   
;B+ Data section
filename db '4096V4.BIN     '
pointer dd 0x0
;E:.
I_END:
   