;Chinese "driver"
   
;B+ Definitions
CIN   equ 3  ;chinese IPC number
MAX   equ 50
;other buffer labels
   
chinese_text     equ CODE_END
text_length      equ CODE_END
color_text       equ CODE_END+4
color_background equ CODE_END+8
text_data        equ CODE_END+12
   
chinese_image           equ (text_data+2*MAX)
chinese_image_set8      equ chinese_image+4
chinese_image_call_from equ chinese_image+8
;message text
chinese_image_width     equ chinese_image+16
chinese_image_image     equ chinese_image+20
   
I_END equ chinese_image_image+3*17*17*MAX
;E:.
   
chinese:
.test:
;B+ Test chinese system language
;B+ It is system switch to chinese ?
  mov  ebx,5
  mov  eax,26
  int  0x40
  cmp  eax,6
  jne  .no_chinese
;E:.
;B+ It is chinese driver load ?
  ;test send
  mov  dword [chinese_image_set8],8
  mov  esi,12+2 ;1 char
  mov  ebx,2
  mov  ecx,CIN
  mov  edx,chinese_text
  mov  word [text_data],1
  mov  dword [text_length],1
  mov  eax,60
  int  0x40
  ;receive event - up to 1 sek
  mov  ebx,01000000b
  mov  eax,40
  int  0x40
  mov  byte [chinese_image],0
.wait_again:
  mov  ebx,100
  mov  eax,23
  int  0x40
  cmp  eax,0
  je   .no_chinese1
  cmp  dword [chinese_image_call_from],CIN
  je   .is_chinese
  call IPC_event
  jmp  .wait_again
.is_chinese:
  mov  ebx,prog_mask
  mov  eax,40
  int  0x40
  mov  [chinese_mode],1
  ret
.no_chinese1:
  mov  ebx,prog_mask
  mov  eax,40
  int  0x40
  mov  [chinese_mode],1
.no_chinese:
  mov  [chinese_mode],0
  ret
;E:.
;E:.
.init_print:
;B+ Init chinese
;B+ Init buffers
  mov  dword [chinese_image],0
  mov  dword [chinese_image_set8],8
;E:.
;B+ Define receive area
  mov  ebx,1
  mov  ecx,chinese_image
  mov  edx,(3*17*17*MAX+4+4*1)
  mov  eax,60
  int  0x40
;E:.
  ret
;E:.
.print:
  ;ebx - [x start]*65536 + [y start]
  ;ecx - text color
  ;edx - text background
  ;esi - pointer to text beginning
  ;edi - text length (in "chars")
;B+ Print chinese text
  cmp  edi,0
  jne  .yes_print
  ret
.yes_print:
 pusha
  mov  byte [chinese_image],1
;B+ Prepare to send
 push ebx
  mov  [text_length],edi
  mov  [color_text],ecx
  mov  [color_background],edx
  ;copy string
  mov  ecx,edi
  shl  ecx,1
  add  ecx,12
 push ecx
  ;esi - input
  mov  edi,text_data
  cld
rep movsb
;E:.
;B+ Send data
  mov  dword [chinese_image_set8],8
 pop  esi
  mov  ebx,2
  mov  ecx,CIN ;driver IPC number (fixed)
  mov  edx,chinese_text
  mov  eax,60
  int  0x40
;E:.
  mov  byte [chinese_image],0
;B+ Wait for event
  ;receive only IPC call
  mov  ebx,01000000b
  mov  eax,40
  int  0x40
  ;wait for IPC event
.wait_again1:
  mov  eax,10
  int  0x40
  cmp  dword [chinese_image_call_from],CIN
  jmp  .is_china
  call IPC_event
  jmp  .wait_again1
.is_china:
  ;restore event mask
  mov  ebx,prog_mask
  mov  eax,40
  int  0x40
;E:.
;B+ Print text
  mov  ebx,chinese_image_image
  mov  ecx,[chinese_image_width]
  shl  ecx,16
  mov  cx,17
 pop  edx
  mov  eax,7
  int  0x40
;E:.
 popa
  ret
;E:.
   
chinese_mode dd 0x0
   